"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var ReactRedux = _interopRequireWildcard(require("react-redux"));

var pfReactTable = _interopRequireWildcard(require("@patternfly/react-table"));

var reactRouterDom = _interopRequireWildcard(require("react-router-dom"));

var _inventoryDependencies = require("@redhat-cloud-services/frontend-components-utilities/inventoryDependencies");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var AsyncInventory = function AsyncInventory(_ref) {
  var fallback = _ref.fallback,
      onLoad = _ref.onLoad,
      innerRef = _ref.innerRef,
      component = _ref.component,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["fallback", "onLoad", "innerRef", "component"]);
  var store = (0, ReactRedux.useStore)();

  var _useState = (0, _react.useState)(),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      InvCmp = _useState2[0],
      setInvCmp = _useState2[1];

  (0, _react.useEffect)(function () {
    (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _yield$insights$loadI, inventoryConnector, rest, _inventoryConnector, InvComponent;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return insights.loadInventory({
                ReactRedux: ReactRedux,
                react: _react["default"],
                reactRouterDom: reactRouterDom,
                pfReactTable: pfReactTable,
                pfReact: _inventoryDependencies.reactCore
              });

            case 2:
              _yield$insights$loadI = _context.sent;
              inventoryConnector = _yield$insights$loadI.inventoryConnector;
              rest = (0, _objectWithoutProperties2["default"])(_yield$insights$loadI, ["inventoryConnector"]);
              onLoad(rest);
              _inventoryConnector = inventoryConnector(store), InvComponent = _inventoryConnector[component];
              setInvCmp(function () {
                return InvComponent;
              });

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }, []);
  return InvCmp ? /*#__PURE__*/_react["default"].createElement(InvCmp, (0, _extends2["default"])({
    ref: innerRef
  }, props)) : fallback || /*#__PURE__*/_react["default"].createElement(_react.Fragment, null);
};

AsyncInventory.propTypes = {
  fallback: _propTypes["default"].any,
  onLoad: _propTypes["default"].func,
  component: _propTypes["default"].string,
  innerRef: _propTypes["default"].object
};
AsyncInventory.defaultProps = {
  onLoad: function onLoad() {
    return undefined;
  },
  component: ''
};
var _default = AsyncInventory;
exports["default"] = _default;